You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

400 lines
18 KiB

  1. #!/bin/bash
  2. set -e
  3. cd "$(readlink -f $(dirname $0))"
  4. if [ -n "${GBP_BUILD_DIR}" ]; then
  5. cd "$GBP_BUILD_DIR"
  6. fi
  7. VERSION=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
  8. DISTRIBUTION=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
  9. LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/contrib/macros.h | sed 's/\.$//')"
  10. LIBAPTINSTVERSION="$(sed -nr 's/set\(MAJOR ([^)]*)\)/\1/p' apt-inst/CMakeLists.txt)"
  11. librarysymbolsfromfile() {
  12. local MISSING="$(grep '^+#MISSING' "$1")"
  13. local SYMVER="$2"
  14. echo '=== Missing optional symbols:'
  15. echo -n "$MISSING" | grep '|optional=' || true
  16. echo '=== Missing required symbols:'
  17. echo -n "$MISSING" | grep -v '|optional=' || true
  18. echo '=== New symbols:'
  19. grep '^+ ' "$1" | grep -v '^+ (c++' | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
  20. echo " (c++)\"${line}@${SYMVER}\" $VERSION"
  21. done | sort -u
  22. }
  23. test_deb_control() {
  24. echo "Package: apt-test-depends"
  25. echo "Version: 1.0"
  26. echo "Architecture: all"
  27. printf "Depends:"
  28. (
  29. for i in Build-Depends Build-Depends-Indep Build-Depends-Arch; do
  30. grep-dctrl -ns $i -S apt ./debian/control && echo ,
  31. done
  32. grep-dctrl -ns Depends -F Tests run-tests ./debian/tests/control
  33. ) | tr '\n' ' '\
  34. | sed -r -e 's#<[^,<>()@]*>##g' \
  35. -e 's#@[^,<>()@]*@##g' \
  36. -e 's#\[linux-any\]*##g' \
  37. -e 's#\[[^][]*\]*##g' \
  38. -e 's#dpkg-dev \([^)]*\)#dpkg-dev#g' \
  39. -e 's#debhelper \([^)]*\)#debhelper#g' \
  40. -e 's#g\+\+ \([^)]*\)#g++#g' \
  41. -e 's#@##g' \
  42. -e 's#,(\s+,)+#, #g' \
  43. -e 's#\s+# #g'
  44. }
  45. if [ "$1" = 'pre-export' ]; then
  46. libraryversioncheck() {
  47. local LIBRARY="$1"
  48. local VERSION="$2"
  49. if [ ! -e "debian/${LIBRARY}${VERSION}.symbols" ]; then
  50. echo >&2 "Library ${LIBRARY} in version ${VERSION} has no symbols file! (maybe forgot to rename?)"
  51. exit 1
  52. fi
  53. if [ "$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")" != "${LIBRARY}.so.${VERSION} ${LIBRARY}${VERSION} #MINVER#" ]; then
  54. echo >&2 "Library ${LIBRARY}${VERSION} has incorrect version in symbol header! (»$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")«)"
  55. exit 2
  56. fi
  57. }
  58. libraryversioncheck 'libapt-pkg' "$LIBAPTPKGVERSION"
  59. libraryversioncheck 'libapt-inst' "$LIBAPTINSTVERSION"
  60. if [ "$DISTRIBUTION" = 'sid' ]; then
  61. echo >&2 '»sid« is not a valid distribution. Replace it with »unstable« for you'
  62. sed -i -e 's/) sid; urgency=/) unstable; urgency=/' debian/changelog
  63. DISTRIBUTION='unstable'
  64. elif [ "$DISTRIBUTION" = 'UNRELEASED' ]; then
  65. echo >&2 'WARNING: Remember to change to a valid distribution for release'
  66. VERSION="$VERSION~$(date +%Y%m%d)"
  67. fi
  68. sed -i -e "s/^set(PACKAGE_VERSION \".*\")$/set(PACKAGE_VERSION \"${VERSION}\")/" CMakeLists.txt
  69. sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
  70. # update the last-modification field of manpages based on git changes
  71. grep --files-with-matches '<date>' doc/*.xml | while read file; do \
  72. LASTMOD="$(date -d "@$(git log -i --format='%at' --max-count=1 --invert-grep --fixed-strings --grep 'review
  73. typo
  74. release
  75. Git-Dch: Ignore
  76. Gbp-Dch: ignore' "$file")" '+%Y-%m-%dT00:00:00Z')"
  77. sed -i -e "s#^\([ ]\+\)<date>.*</date>\$#\1<date>$LASTMOD</date>#" "$file"
  78. done
  79. if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
  80. "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
  81. echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
  82. [ -e build ] || mkdir build
  83. ( cd build && cmake .. )
  84. cmake --build build --target update-po -- -j 4
  85. fi
  86. elif [ "$1" = 'pre-build' ]; then
  87. if [ "$DISTRIBUTION" = "UNRELEASED" ]; then
  88. echo 'BUILDING AN UNRELEASED VERSION'
  89. else
  90. CONFVERSION="$(sed -ne "s/^set(PACKAGE_VERSION \"\(.*\)\")$/\1/p" CMakeLists.txt)"
  91. if [ "$VERSION" != "$CONFVERSION" ]; then
  92. echo "changelog (${VERSION}) and CMakeLists.txt (${CONFVERSION}) talk about different versions!"
  93. echo "You probably want to run »./prepare-release pre-export« to fix this."
  94. exit 1
  95. fi
  96. NEWSDISTRIBUTION=$(dpkg-parsechangelog -l debian/NEWS | sed -n -e '/^Distribution:/s/^Distribution: //p')
  97. if [ "$NEWSDISTRIBUTION" = 'UNRELEASED' ]; then
  98. echo "changelog (${VERSION}) has a distribution (${DISTRIBUTION}) set, while the NEWS file hasn't!"
  99. echo "You probably want to edit »debian/NEWS« to fix this."
  100. exit 1
  101. fi
  102. fi
  103. elif [ "$1" = 'post-build' ]; then
  104. if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
  105. echo >&2 "REMEMBER: Tag this release with »git tag -s ${VERSION}« if you are satisfied"
  106. else
  107. echo >&2 'REMEMBER: Change to a valid distribution before release'
  108. fi
  109. dpkg-checkbuilddeps -d 'libxml2-utils'
  110. HEADERBLUEPRINT="$(mktemp)"
  111. sed -n '1,/^$/p' doc/apt.8.xml > "$HEADERBLUEPRINT"
  112. find doc -mindepth 1 -maxdepth 1 -type f -name '*.xml' | while read FILE; do
  113. if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
  114. echo >&2 "WARNING: Manpage $FILE has not the usual header! (see diff below)"
  115. sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
  116. fi
  117. done
  118. sed -n '1,/^$/p' doc/guide.dbk > "$HEADERBLUEPRINT"
  119. find doc -mindepth 1 -maxdepth 1 -type f -name '*.dbk' | while read FILE; do
  120. if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
  121. echo >&2 "WARNING: Documentation $FILE has not the usual header (see diff below)!"
  122. sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
  123. fi
  124. done
  125. rm "$HEADERBLUEPRINT"
  126. # check the manpages with each vendor for vendor-specific errors…
  127. find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
  128. ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
  129. if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
  130. echo >&2 "WARNING: original docbook manpages have errors with vendor ${DISTRO}!"
  131. fi
  132. done
  133. # lets assume we will always have a german manpage translation
  134. if [ -e */doc/de/ -o -e doc/de ]; then
  135. # … but check the translations only with one vendor for translation-specific errors
  136. if ! xmllint --path /vendor/$(./vendor/getinfo current)/ \
  137. --path doc/ \
  138. --nonet --valid --noout $(find doc/ */doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
  139. echo >&2 "WARNING: translated docbook manpages have errors!"
  140. fi
  141. else
  142. echo >&2 "ERROR: translated manpages need to be build before they can be checked!"
  143. fi
  144. rm -f doc/apt-vendor.ent
  145. elif [ "$1" = 'library' ]; then
  146. librarysymbols() {
  147. local libname=$(echo "${1}" | cut -c 4-)
  148. local buildlib="build/bin/${1}.so.${2}"
  149. for dir in $libname */$libname; do
  150. local new_buildlib="$dir/${1}.so.${2}"
  151. if [ -r "${new_buildlib}" ] && [ ! -e "$buildlib" -o "$new_buildlib" -nt "$buildlib" ]; then
  152. local buildlib="${new_buildlib}"
  153. fi
  154. done
  155. if [ ! -r "$buildlib" ]; then
  156. echo "ERROR: The library ${1} has to be built before symbols can be checked!"
  157. return
  158. fi
  159. echo "Checking $1 in version $2 build at $(stat -L -c '%y' "$buildlib")"
  160. local tmpfile=$(mktemp)
  161. dpkg-gensymbols -p${1}${2} -e${buildlib} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
  162. librarysymbolsfromfile "$tmpfile" "$(echo "${1}" | cut -c 4- | tr -d '-' | tr 'a-z' 'A-Z')_${2}"
  163. rm -f $tmpfile
  164. }
  165. librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
  166. echo
  167. librarysymbols 'libapt-inst' "${LIBAPTINSTVERSION}"
  168. elif [ "$1" = 'buildlog' ]; then
  169. while [ -n "$2" ]; do
  170. librarysymbolsfromfile "$2" 'UNKNOWN'
  171. shift
  172. done
  173. elif [ "$1" = 'travis-ci' ]; then
  174. apt-get install -qy --no-install-recommends dctrl-tools equivs gdebi-core moreutils
  175. test_deb_control > test-control
  176. equivs-build test-control
  177. gdebi -n apt-test-depends_1.0_all.deb
  178. elif [ "$1" = 'coverage' ]; then
  179. DIR="${2:-./coverage}"
  180. git clean -dfX # remove ignored build artifacts for a clean start
  181. make CFLAGS+='--coverage' CXXFLAGS+='--coverage'
  182. LCOVRC='--rc geninfo_checksum=1 --rc lcov_branch_coverage=1'
  183. mkdir "$DIR"
  184. lcov --no-external --directory . --capture --initial --output-file "${DIR}/apt.coverage.init" ${LCOVRC}
  185. make test || true
  186. ./test/integration/run-tests -q || true
  187. lcov --no-external --directory . --capture --output-file "${DIR}/apt.coverage.run" ${LCOVRC}
  188. lcov -a "${DIR}/apt.coverage.init" -a "${DIR}/apt.coverage.run" -o "${DIR}/apt.coverage.total" ${LCOVRC}
  189. cp "${DIR}/apt.coverage.total" "${DIR}/apt.coverage.fixed"
  190. rewritefile() {
  191. file="$1"
  192. shift
  193. name="$(basename "$file")"
  194. while [ -n "$1" ]; do
  195. if [ -r "$1/$name" ]; then
  196. sed -i "s#$file#$1/$name#" "${DIR}/apt.coverage.fixed"
  197. break
  198. fi
  199. shift
  200. done
  201. if [ -z "$1" ]; then
  202. echo >&2 "Coverage data captured for unknown file $file"
  203. fi
  204. }
  205. grep 'build/include/' "${DIR}/apt.coverage.fixed" | sed "s#^SF:$(pwd)/##" | while read file; do
  206. rewritefile "$file" 'apt-pkg' 'apt-pkg/deb' 'apt-pkg/edsp' 'apt-pkg/contrib' \
  207. 'apt-inst' 'apt-inst/deb' 'apt-inst/contrib' 'apt-private'
  208. done
  209. genhtml --output-directory "${DIR}" "${DIR}/apt.coverage.fixed" ${LCOVRC}
  210. elif [ "$1" = 'spellcheckers' -o "$1" = 'lint' ]; then
  211. is_available() {
  212. if dpkg-checkbuilddeps -d "$1" 2>/dev/null; then
  213. return 0
  214. fi
  215. echo "### SKIPPING ${2:-$1} functionality as ${1} isn't installed"
  216. }
  217. if is_available 'codespell'; then
  218. echo '### codespell in source directories:'
  219. codespell --enable-colors $(find . -mindepth 1 -maxdepth 1 -type d \! -name '.git' \! -name 'doc' \! -name 'po' \! -name 'build' \! -name 'test') \
  220. | grep -v -e '^.*debian/changelog.*Troup.*==>.*Troupe.*$' \
  221. -e '^.*debian/changelog.*readd.*==>.*readd.*$' \
  222. -e '^.*debian/changelog.*Tim.*==>.*Time.*$' \
  223. -e '^.*apt-pkg/contrib/fileutl\.cc.*creat.*==>.*create.*$' \
  224. -e '^.*apt-pkg/pkgcache\.h.*mmaped.*==>.*mapped.*$' \
  225. -e '^.*apt-pkg/pkgcachegen\.cc.*mmaped.*==>.*mapped.*$' \
  226. -e '^.*apt-pkg/contrib/mmap\.h.*mmaped.*==>.*mapped.*$' \
  227. -e '^.*cmdline/apt-key\.in.*dashs.*==>.*dashes.*$' \
  228. -e '^.*methods/aptmethod\.h.*creat.*==>.*create.*$' \
  229. -e '^.*dselect/install.*ans.*==>.*and.*$' \
  230. -e '^.*ftparchive/writer\.h.*Delink.*==>.*Unlink.*$' \
  231. -e '^.*ftparchive/writer\.cc.*De[Ll]ink.*==>.*[Uu]nlink.*$' \
  232. || true
  233. echo '### codespell in testcases:'
  234. codespell --enable-colors $(find test -type f \! -name 'status-*' \! -name 'Packages-*' \! -name '*.deb' \! -name '*.sec' \! -name '*.pub' \! -name '*.db') \
  235. | grep -v -e '^.*test/libapt/file-helpers\.cc.*creat.*==>.*create.*$' \
  236. -e '^.*test/libapt/tagfile_test\.cc.*tyes.*==>.*types.*$' \
  237. -e '^.*test/libapt/strutil_test\.cc.*Fiel.*==>.*Feel.*$' \
  238. -e '^.*test/libapt/cdromfindpackages_test\.cc.*Signatur.*==>.*Signature.*$' \
  239. -e '^.*test/integration/skip-bug-601016-description-translation.*Paket.*==>.*Packet.*$' \
  240. -e '^.*test/integration/skip-bug-601016-description-translation.*Wege.*==>.*Wedge.*$' \
  241. -e '^.*test/integration/skip-bug-601016-description-translation.*Methoden.*==>.*Methods.*$' \
  242. -e '^.*test/integration/test-apt-update-not-modified.*readd.*==>.*readd.*$' \
  243. || true
  244. echo '### codespell in documentation:'
  245. codespell --enable-colors doc/*.xml doc/*.txt doc/*.dbk doc/*.ent doc/*.cmake.in doc/xml.add doc/po4a.conf doc/examples doc/po/apt-doc.pot \
  246. po/apt-all.pot README.* COPYING \
  247. | grep -v -e '^.*po/apt-all\.pot.*DeLink.*==>.*unlink.*$' \
  248. || true
  249. fi
  250. if is_available 'lintian' 'spellintian'; then
  251. echo '### spellintian in source directories:'
  252. {
  253. for DIR in $(find . -mindepth 1 -maxdepth 1 -type d \! -name '.git' \! -name 'doc' \! -name 'po' \! -name 'build' \! -name 'test'); do
  254. spellintian $(find "$DIR" -type f)
  255. done
  256. } \
  257. | grep -v \
  258. -e '^.*: long long (duplicate word) -> long$' \
  259. -e '^./apt-pkg/pkgcache.h: ID ID (duplicate word) -> ID$' \
  260. -e '^./apt-pkg/contrib/mmap.cc: WorkSpace WorkSpace (duplicate word) -> WorkSpace$' \
  261. -e '^./apt-pkg/contrib/md5.cc: z z (duplicate word) -> z$' \
  262. -e '^./apt-pkg/metaindex.cc: const const (duplicate word) -> const$' \
  263. -e '^./apt-pkg/acquire-method.cc: QueueBack QueueBack (duplicate word) -> QueueBack$' \
  264. -e '^./CMake/Translations.cmake: domain domain (duplicate word) -> domain$' \
  265. -e '^./CMake/apti18n.h.in: m m (duplicate word) -> m$' \
  266. -e '^./CMake/run_if_exists.sh: fi fi (duplicate word) -> fi$' \
  267. -e '^./ftparchive/byhash.cc: ByHash ByHash (duplicate word) -> ByHash$' \
  268. -e '^./ftparchive/writer.cc: this Packages -> these packages$' \
  269. -e '^./ftparchive/byhash.h: ByHash ByHash (duplicate word) -> ByHash$' \
  270. -e '^./cmdline/apt-key.in: done done (duplicate word) -> done$' \
  271. -e '^./cmdline/apt-key.in: fi fi (duplicate word) -> fi$' \
  272. -e '^./cmdline/apt-key.in: echo echo (duplicate word) -> echo$' \
  273. -e '^./triehash/.travis.yml: perl perl (duplicate word) -> perl$' \
  274. -e '^./triehash/README.md: Performance Performance (duplicate word) -> Performance$' \
  275. -e '^./debian/apt.apt-compat.cron.daily: fi fi (duplicate word) -> fi$' \
  276. -e '^./debian/apt.auto-removal.sh: done done (duplicate word) -> done$' \
  277. -e '^./debian/apt.systemd.daily: fi fi (duplicate word) -> fi$' \
  278. -e '^./debian/apt.postinst: fi fi (duplicate word) -> fi$' \
  279. -e '^./methods/http.cc: Sz Sz (duplicate word) -> Sz$' \
  280. -e '^./methods/ftp.cc: AFMap AFMap (duplicate word) -> AFMap$' \
  281. -e '^./dselect/install: fi fi (duplicate word) -> fi$' \
  282. -e '^./CMake/Documentation.cmake: endforeach endforeach (duplicate word) -> endforeach$' \
  283. -e '^./apt-pkg/deb/deblistparser.cc: c c (duplicate word) -> c$' \
  284. -e '^./apt-private/private-install.cc: result result (duplicate word) -> result$' \
  285. -e '^./debian/changelog: the the (duplicate word) -> the$' \
  286. -e '^./debian/changelog: procceed -> proceed$' \
  287. -e '^./methods/aptmethod.h: QueueBack QueueBack (duplicate word) -> QueueBack$' \
  288. || true
  289. echo '### spellintian in testcases:'
  290. spellintian $(find test -type f \! -name 'status-*' \! -name 'Packages-*' \! -name '*.deb' \! -name '*.sec' \! -name '*.pub' \! -name '*.db') \
  291. | grep -v \
  292. -e '^.*: long long (duplicate word) -> long$' \
  293. -e '^test/integration/.*: fi fi (duplicate word) -> fi$' \
  294. -e '^test/integration/.*: done done (duplicate word) -> done$' \
  295. -e '^test/integration/.*: echo echo (duplicate word) -> echo$' \
  296. -e '^test/integration/test-00-commands-have-help: moo moo (duplicate word) -> moo$' \
  297. -e '^test/integration/test-apt-cache: bar bar (duplicate word) -> bar$' \
  298. -e '^test/integration/test-sourceslist-trusted-options: everythingsucceeds everythingsucceeds (duplicate word) -> everythingsucceeds$' \
  299. -e '^test/integration/test-sourceslist-trusted-options: everythingfails everythingfails (duplicate word) -> everythingfails$' \
  300. -e '^test/integration/test-apt-get-changelog: foo foo (duplicate word) -> foo$' \
  301. -e '^test/integration/test-ubuntu-bug-761175-remove-purge: testround testround (duplicate word) -> testround$' \
  302. -e '^test/integration/test-apt-get-download: apt apt (duplicate word) -> apt$' \
  303. -e '^test/integration/test-apt-showlist-orgroup-in-recommends: zzz zzz (duplicate word) -> zzz$' \
  304. -e '^test/integration/test-bug-691453-apt-cache-search-multi-pattern: bar bar (duplicate word) -> bar$' \
  305. -e '^test/integration/test-allow: hold hold (duplicate word) -> hold$' \
  306. -e '^test/integration/test-apt-by-hash-update: ensureitsbroken ensureitsbroken (duplicate word) -> ensureitsbroken$' \
  307. -e '^test/integration/test-apt-source-and-build-dep: foo foo (duplicate word) -> foo$' \
  308. || true
  309. echo '### spellintian in documentation:'
  310. spellintian doc/*.xml doc/*.txt doc/*.dbk doc/*.ent doc/*.cmake.in doc/xml.add doc/po4a.conf doc/examples/* doc/po/apt-doc.pot po/apt-all.pot README.* COPYING \
  311. | grep -v \
  312. -e '^doc/examples/configure-index: https https (duplicate word) -> https$' \
  313. || true
  314. fi
  315. # stay true to the old name
  316. if [ "$1" = 'spellcheckers' ]; then exit; fi
  317. if is_available 'i18nspector'; then
  318. echo '### i18nspector on translation files:'
  319. i18nspector po/*.po po/*.pot doc/po/*.pot doc/po/*.po \
  320. | grep -v \
  321. -e '^I: po/es.po: duplicate-header-field X-POFile-SpellExtra$' \
  322. || true
  323. fi
  324. elif [ "$1" = "merge-translations" ]; then
  325. if [ -z "$2" ]; then
  326. echo "Usage:\t$0 $1 <branch to merge from>" >&2
  327. exit 1
  328. fi
  329. for i in {doc/,}po/*.po ; do
  330. # 1. concatenate the translations, picking new translations
  331. # 2. merge the translations so we only have matching translations left
  332. # 3. remove any newly introduced obsolete translations (only in $2)
  333. # 4. concatenate again to restore "old" obsolete translations
  334. # 5. write output
  335. msgcat --use-first <(git show $2:$i) $i \
  336. | msgmerge --no-fuzzy --previous - $i \
  337. | msgattrib --no-obsolete - \
  338. | msgcat --use-first - $i \
  339. | sponge $i
  340. done
  341. else
  342. echo >&1 "Usage:\t$0 pre-export
  343. \t$0 pre-build
  344. \t$0 post-build
  345. Updating po-files and versions as well as some basic checks are done
  346. by »pre-export« which needs to be run before package building.
  347. If you use »gbp buildpackage« you will be notified if you forget.
  348. »pre-build« and »post-build« can be used to run some more or less
  349. useful checks automatically run by »gbp« otherwise.
  350. \t$0 library
  351. \t$0 buildlog filename…
  352. »library« and »buildlog« aren't run automatically but can be useful for
  353. maintaining the (more or less experimental) symbols files we provide.
  354. »library« displays the diff between advertised symbols and the once provided
  355. by the libraries, while »buildlog« extracts this diff from the buildlogs.
  356. Both will format the diff properly.
  357. \t$0 travis-ci
  358. \t$0 coverage [output-dir]
  359. »travis-ci« is a shortcut to install all build- as well as test-dependencies
  360. used by .travis.yml.
  361. »coverage« does a clean build with the right flags for coverage reporting,
  362. runs all tests and generates a html report in the end.
  363. \t$0 spellcheckers
  364. »spellcheckers« runs »codespell« and »spellintian« on the appropiate files and
  365. filters out obvious false positives.
  366. \t$0 merge-translations branch
  367. Merge translations from the given branch.
  368. "
  369. fi